import 'package:zap_architecture/src/response.dart';
import 'package:zap_architecture/zap_architecture.dart';

/// Created by Musa Usman on 28.08.2020
/// Copyright © 2020 Musa Usman. All rights reserved.

class Status {
  bool get isClear => !loading && !error;

  bool loading = false;
  bool error = false;
  String errorMessage;
  String friendlyErrorMessage;

  Status.clear() {
    this.loading = false;
    this.error = false;
    this.errorMessage = null;
  }

  Status.loading()
      : this.loading = true,
        this.error = false,
        this.errorMessage = null;

  Status.error([this.errorMessage = "Something Went Wrong."])
      : this.loading = false,
        this.error = true;

  Status.fromJSON(Response response)
      : this.loading = false,
        this.error = response.success == false,
        this.errorMessage =
            (response.success == false) == true ? response.errorMessage : null;

  @override
  String toString() =>
      "Status(loading: $loading, error: $error, errorMessage: $errorMessage, friendlyErrorMessage: $friendlyErrorMessage)";
}
